#include <Wire.h>
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27,2,1,0,4,5,6,7,3,POSITIVE);

int setdelay = 50;

int setdelay1 = 35;
int setdelay2 = 75;
int setdelay5 = 105;
int setdelay10 = 110;

int setLCDdelay = 4000;

int coin_OneBaht = 0;
int coin_TwoBaht = 0;
int coin_FiveBaht = 0;
int coin_TenBaht = 0;
int total       = 0;

int state_c1;
int state_c2;
int state_c5;
int state_c10;
int state_LCD = 1;

unsigned long ms1=0;
unsigned long ms2=0;
unsigned long ms5=0;
unsigned long ms10=0;
unsigned long msdl=0;
unsigned long msLCD=0;


void setup()
{
  pinMode(PIN_PC0, INPUT);
  pinMode(PIN_PC1, INPUT);
  pinMode(PIN_PC2, INPUT);
  pinMode(PIN_PC3, INPUT);
  
  lcd.begin(16,2);
  lcd.clear();
  // Print a message to the LCD.
  lcd.backlight();
  lcd.setCursor(1,0);
  lcd.print("HelloEveryone!");
  lcd.setCursor(0,1);
  lcd.print("By Soft And Win");
  delay(3000);
}

void loop()
{

  checkstateCoin1();
  checkstateCoin2();
  checkstateCoin5();
  checkstateCoin10();
  LCD_Show();
  
}

void checkstateCoin1()
{
  state_c1 = digitalRead(PIN_PC0);

  if (state_c1 == 1)
  {
    if( ms1 == 0)
    {
      ms1 = millis();
      coin_OneBaht++;
      total = total + 1;
    }    
  }

  if( ms1 != 0)
  {
      if( (millis() - ms1) > setdelay1)
      {
         ms1 = 0;
      }
  }
}

void checkstateCoin2()
{
  state_c2 = digitalRead(PIN_PC1);

  if (state_c2 == 1)
  {
    if( ms2 == 0)
    {
      ms2 = millis();
      coin_TwoBaht++;
      total = total + 2;
    }    
  }

  if( ms2 != 0)
  {
      if( (millis() - ms2) > setdelay2)
      {
         ms2 = 0;
      }
  }
}

void checkstateCoin5()
{
  state_c5 = digitalRead(PIN_PC2);

  if (state_c5 == 1)
  {
    if( ms5 == 0)
    {
      ms5 = millis();
      coin_FiveBaht++;
      total = total + 5;
    }    
  }

  if( ms5 != 0)
  {
      if( (millis() - ms5) > setdelay5)
      {
         ms5 = 0;
      }
  }
}

void checkstateCoin10()
{
  state_c10 = digitalRead(PIN_PC3);

  if (state_c10 == 1)
  {
    if( ms10 == 0)
    {
      ms10 = millis();
      coin_TenBaht++;
      total = total + 10;
    }    
  }

  if( ms10 != 0)
  {
      if( (millis() - ms10) > setdelay10)
      {
         ms10 = 0;
      }
  }
}

void LCD_Show()
{
  if (state_LCD == 1)
  {
    if (msdl == 0)
    {
      msdl = millis();
      lcd.clear();    
      lcd.setCursor(4,0);
      lcd.print("All coin");
      lcd.setCursor(0,1);
      lcd.print("Total = ");
      lcd.print(total); 
    }
  }
  else if (state_LCD == 0)
  {
    if (msdl == 0)
    {
      msdl = millis();
      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print("1   2   5   10  ");
      lcd.setCursor(0,1);
      lcd.print(coin_OneBaht);
      lcd.setCursor(4,1);
      lcd.print(coin_TwoBaht);
      lcd.setCursor(8,1);
      lcd.print(coin_FiveBaht);
      lcd.setCursor(12,1);
      lcd.print(coin_TenBaht); 
    }  
  }

  if( msdl != 0)
  {
    if( (millis() - msdl) > setdelay)
    {
      msdl = 0;
    }
    if( (millis() - msLCD) > setLCDdelay)
    {
      msLCD = millis();
      if (state_LCD == 1)
      {
        state_LCD = 0;
      }
      else if (state_LCD == 0)
      {
        state_LCD = 1;
      }
    }
  }
}
